---
title: ServiceWorkerState
slug: Web/API/ServiceWorkerState
tags:
  - API
  - Interface
  - Reference
  - Service Workers
  - ServiceWorkerState
---
<div>{{APIRef("Service Workers API")}}</div>

<p>The <code><strong>ServiceWorkerState</strong></code> is associated with its {{DOMxRef("ServiceWorker")}}'s state.</p>

<h2 id="Values">Values</h2>

<dl>
 <dt><code>installing</code></dt>
 <dd>The service worker in this state is considered an installing worker. During this state, {{DOMxRef("ExtendableEvent.waitUntil()")}} can be called inside the <code>install</code> event handler to extend the life of the installing worker until the passed promise resolves successfully. This is primarily used to ensure that the service worker is not active until all of the core caches are populated.</dd>
 <dt><code>installed</code></dt>
 <dd>The service worker in this state is considered a waiting worker.</dd>
 <dt><code>activating</code></dt>
 <dd>The service worker in this state is considered an active worker. During this state, {{DOMxRef("ExtendableEvent.waitUntil()")}} can be called inside the <code>onactivate</code> event handler to extend the life of the active worker until the passed promise resolves successfully. No functional events are dispatched until the state becomes activated.</dd>
 <dt><code>activated</code></dt>
 <dd>The service worker in this state is considered an active worker ready to handle functional events.</dd>
 <dt><code>redundant</code></dt>
 <dd>A new service worker is replacing the current service worker, or the current service worker is being discarded due to an install failure.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Service Workers", "#service-worker-state-enum", "ServiceWorkerState")}}</td>
   <td>{{Spec2("Service Workers")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("ServiceWorker.state")}}</li>
</ul>
